searchNodes=[{"doc":"","ref":"nine.html","title":"nine","type":"module"},{"doc":"","ref":"nine.html#compile/2","title":"nine.compile/2","type":"function"},{"doc":"","ref":"nine.html#t:handler/0","title":"nine.handler/0","type":"type"},{"doc":"","ref":"nine.html#t:norm_route/0","title":"nine.norm_route/0","type":"type"},{"doc":"","ref":"nine.html#t:norm_routes/0","title":"nine.norm_routes/0","type":"type"},{"doc":"","ref":"nine_mid.html","title":"nine_mid","type":"module"},{"doc":"","ref":"nine_mid.html#json_request/1","title":"nine_mid.json_request/1","type":"function"},{"doc":"","ref":"nine_mid.html#json_response/1","title":"nine_mid.json_response/1","type":"function"},{"doc":"","ref":"nine_mid.html#urlencoded_params/1","title":"nine_mid.urlencoded_params/1","type":"function"},{"doc":"","ref":"nine_util.html","title":"nine_util","type":"module"},{"doc":"","ref":"nine_util.html#get_method/1","title":"nine_util.get_method/1","type":"function"},{"doc":"","ref":"nine_util.html#not_found/1","title":"nine_util.not_found/1","type":"function"},{"doc":"","ref":"nine_util.html#redirect/2","title":"nine_util.redirect/2","type":"function"},{"doc":"A data-driven routing library for elli web servers. nine consists of a router compiler, middleware, and utility functions. You can think of it as a micro web framework. The goal of nine is to allow developers to precisely compose middleware in an intuitive way. A side effect of this is that it makes writing web servers with elli more accessible. Despite elli's performance, it is not as widely used. nine allows developers to not have to choose between performance and ease of use.","ref":"readme.html","title":"nine","type":"extras"},{"doc":"rebar3 compile","ref":"readme.html#build","title":"nine - Build","type":"extras"},{"doc":"cd example rebar3 compile rebar3 shell Navigate to localhost:3000. Please see example/README.md for more details.","ref":"readme.html#demo","title":"nine - Demo","type":"extras"},{"doc":"nine:compile takes a router config and compiles it into an Erlang module at runtime using forms . The generated module will have two functions: handle/2 and handle_event/3 , in accordance with the elli_callback behaviour. The handle function generated has a few important details. It will wrap the elli req and create Context map that will always have these keys: \#{ path =&gt; elli_request : path ( Req ) , method =&gt; Req # req . method , req =&gt; Req } If URL params are specified as part of the route then params key will also be included with the corresponding named params in map. So if the path was /foo/:name/:id, then the Context map will look like this: \#{ params =&gt; \#{ name =&gt; &lt;&lt; &quot;hackercat&quot; &gt;&gt; , id =&gt; &lt;&lt; &quot;42&quot; &gt;&gt; } , path =&gt; . . . , method =&gt; . . . , req =&gt; . . . } Halting is implemented by wrapping each call to middleware and handlers in a case statement checking for a response key. If such a key exists, then response is immediately sent, instead of triggering further middleware. A middleware chain like this: [ { nine_mid , json_request } , { todo_handler , post_todo } ] Will generate Erlang forms along the lines of: case nine_mid : json_request ( Req ) of \#{ response := _ } = Resp -&gt; Resp ; Req1 -&gt; case todo_handler : post_todo ( Req1 ) of \#{ response := _ } = Resp1 -&gt; Resp1 ; Req2 -&gt; Req2 end end","ref":"readme.html#how-it-works","title":"nine - How It Works","type":"extras"},{"doc":"Write a request handler: - module ( basic ) . - export ( [ index / 1 ] ) . index ( _ Context ) -&gt; { 200 , [ ] , &lt;&lt; &quot;Hello World!&quot; &gt;&gt; } . The index function returns a standard elli response. Compile a router config: nine : compile ( example_router , \#{ &lt;&lt; &quot;/&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;GET&quot; &gt;&gt; =&gt; { basic , index } } } ) . This will generate a module example_router that provides two functions handle/2 , and handle_event/3 . Then you can initialize your elli web server in your apps supervisor like so: init ( [ ] ) -&gt; SupFlags = \#{ strategy =&gt; one_for_all , intensity =&gt; 0 , period =&gt; 1 } , ElliOpts = [ { callback , example_router } , { port , 3000 } ] , ChildSpecs = [ { example_http , { elli , start_link , [ ElliOpts ] } , permanent , 5000 , worker , [ elli ] } ] , { ok , { SupFlags , ChildSpecs } } . Notice how example_router is specified as the callback.","ref":"readme.html#basic-usage","title":"nine - Basic Usage","type":"extras"},{"doc":"Handler A handler is specified as {module, function}. Example: { basic_handlers , get_todo } basic_handlers being the module, and get_todo is the function. nine compiler will take this handler config and generate a function call. Method Configs A method config is a map with keys corresponding to HTTP methods and a value that is a handler. \#{ &lt;&lt; &quot;GET&quot; &gt;&gt; =&gt; { todo_handler , get_todo } , &lt;&lt; &quot;POST&quot; &gt;&gt; =&gt; { todo_handler , post_todo } , &lt;&lt; &quot;PUT&quot; &gt;&gt; =&gt; { todo_handler , put_todo } , &lt;&lt; &quot;PATCH&quot; &gt;&gt; =&gt; { todo_handler , patch_todo } , &lt;&lt; &quot;DELETE&quot; &gt;&gt; =&gt; { todo_handler , delete_todo } , &lt;&lt; &quot;_&quot; &gt;&gt; =&gt; { todo_handler , any_todo } } The example above demonstrates the set of keys possible in a method config. _ will match any method. Path Configs A path config is a map with url paths or segments as keys and method configs or path configs as values. \#{ &lt;&lt; &quot;/&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;GET&quot; &gt;&gt; =&gt; { basic_handler , index } } , &lt;&lt; &quot;/foo&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;POST&quot; &gt;&gt; =&gt; { basic_handler , post_foo } } } . This Path Config will route to the paths / and /foo. Nested Path Configs A value in a path config can also be another path config. This example demonstrates nested path configs: \#{ &lt;&lt; &quot;/api&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;/v1&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;GET&quot; &gt;&gt; =&gt; { basic_handler , index } } , &lt;&lt; &quot;/v2&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;GET&quot; &gt;&gt; =&gt; { basic_handler2 , index } } } } . This demonstrates how one can describe multiple api versions with a nested path config. The paths for these are &quot;/api/v1&quot; and &quot;/api/v2&quot;. Due to implementation details the above config is equivalent to this: \#{ &lt;&lt; &quot;/api/v1&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;GET&quot; &gt;&gt; =&gt; { basic_handler , index } } , &lt;&lt; &quot;/api/v2&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;GET&quot; &gt;&gt; =&gt; { basic_handler2 , index } } } . Despite the equivalence, we will see how nesting is key to precisely composing middleware. URL Path Params nine builds in a way to have named parameters in the URL. A path like /todo/:id will result in the context map including the params key. The value of the params will be \#{id =&gt; &lt;&lt;&quot;id1&quot;&gt;&gt;} . In case you are worried about atoms coming from user data, it is okay for id to be an atom because it is a static value set at compile time. nine also supports partial path params like /person/num:ber will result in a params map looking like \#{ber =&gt; &lt;&lt;&quot;2&quot;&gt;&gt;} for example. This is similar to how Phoenix works with routing. Wildcard nine supports catch all routes with * in the path. For example: &lt;&lt;&quot;/*&quot;&gt;&gt; will match any route. We can also put a wildcard at the suffix of a path: &lt;&lt;&quot;/foo/*&quot;&gt;&gt; will match a route like &lt;&lt;&quot;/foo/bar&quot;&gt;&gt; . Wildcards can only be at the end of a path. This is similar to how Phoenix works with catch all routes. The reason for this is the routing uses Erlang pattern matching, so it must follow the same rules. Path Sorting A number of nine 's features conflict with the linear nature of Erlang's pattern matching. How do wildcards and path params not shadow other requests? More importantly, how is order guaranteed when the config is a map? After flattening the router config, nine sorts the routes by the aggregated path value. The sorting function works alphabetically in addition to these rules: &lt;&lt; &quot;/foo/bar&quot; &gt;&gt; &lt; &lt;&lt; &quot;/foo/:id&quot; &gt;&gt; &lt; &lt;&lt; &quot;/foo/*&quot; &gt;&gt; &lt; &lt;&lt; &quot;/*&quot; &gt;&gt; If a path is less than another it will precede it in the list. The sorting function is designed to minimize shadowing. The sorting function is a bit complicated so its possible edge cases are there, but for the most part, this works well. It even allows router configs like this: \#{ &lt;&lt; &quot;/todo/:id&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;GET&quot; &gt;&gt; =&gt; { basic_handler , get_todo } } , &lt;&lt; &quot;/todo/foo&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;GET&quot; &gt;&gt; =&gt; { basic_handler , get_foo } } } . This means requests at /todo/foo will always hit the handler basic_handler:get_foo , despite the /todo/:id being a path param. Middleware Middleware are specified just like handlers, in fact they are the same thing! An example middleware might look like: { nine_mid , json_response } Middleware are functions that take a Context as input and output a Context or an elli response. One could write a logging middleware like this: logging_middleware ( Context ) -&gt; logger : debug ( \#{ context =&gt; Context } ) , Context . Or we could make a middleware that adds some data to the Context: message_middleware ( Context ) -&gt; Context \#{ message =&gt; &lt;&lt; &quot;Hello, World!&quot; &gt;&gt; } . Middleware are helpful in all sorts of situations and allow developers to write web apps in a DRY way. Middleware Chains nine specifies middleware chaining with lists in the router config. Middleware chains can wrap path configs, method configs, and handlers. The order specified in the chain determines the order of execution. For example: [ { nine_mid , urlencoded_params } , { todo_handler , post_todo } ] Will generate a sequence of function calls where nine_mid:urlencoded_params is called first, and the result is passed to todo_handler:post_todo . Allowing post_todo to be implemented like so: post_todo ( Context = \#{ params := \#{ &lt;&lt; &quot;body&quot; &gt;&gt; := Body } } ) -&gt; todo_db : insert ( Body ) , nine_util : redirect ( Context , &lt;&lt; &quot;/&quot; &gt;&gt; ) . post_todo can expect the params key to be filled with data because urlencoded_params is called first. Middleware chains can wrap method configs and path configs. Middleware chains can even wrap the entire router config! \#{ &lt;&lt; &quot;/api&quot; &gt;&gt; =&gt; [ { nine_mid , json_request } , \#{ &lt;&lt; &quot;POST&quot; &gt;&gt; =&gt; { todo_handler , post_todo_json } , &lt;&lt; &quot;DELETE&quot; &gt;&gt; =&gt; { todo_handler , delete_todo_json } } ] } . The middleware nine_mid:json_request is specified to occur before all the handlers in the method config. Here is an example of a middleware chain around the entire config: [ { example_mid , log_request } , \#{ &lt;&lt; &quot;/&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;GET&quot; &gt;&gt; =&gt; { example_handler , stuff } } } , { example_mid , log_response } ] . Here any request will trigger log_request at the beginning of the pipeline, and log_response at the end of the pipeline. We can combine middleware chaining with nested path configs: \#{ &lt;&lt; &quot;/api&quot; &gt;&gt; =&gt; [ { example_mid , v1 } , \#{ &lt;&lt; &quot;/v1&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;GET&quot; &gt;&gt; =&gt; { example_handler , get_thing } } , &lt;&lt; &quot;/other&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;GET&quot; &gt;&gt; =&gt; { example_handler , other } } } ] , &lt;&lt; &quot;*&quot; &gt;&gt; =&gt; \#{ &lt;&lt; &quot;_&quot; &gt;&gt; =&gt; { nine_mid , not_found } } } . Halting There are situations where we want to return a response immediately without finishing the middleware chain. This is known as halting. nine makes this possible because each middleware and handler call is wrapped in a case statement checking for the response key. If a handler or middleware returns a Context map with the response key it will immediately be sent without triggering further middleware.","ref":"readme.html#router-config","title":"nine - Router Config","type":"extras"},{"doc":"nine was inspired by other composable middleware tools. ring - Standard Clojure HTTP abstraction for web servers ataraxy - data driven routing library for Clojure Plug.Router - Ecosystem defining Elixir HTTP middleware golang http middleware - Standard Library Golang Middleware Pattern Cowboy Router - cowboy router is compiled into a lookup table","ref":"readme.html#inspirations","title":"nine - Inspirations","type":"extras"},{"doc":"The name nine comes from &quot;nine nines&quot;. Middleware was originally intended to look like Ring's, but wasn't compatible with Erlang's pattern matching lookups.","ref":"readme.html#fun-facts","title":"nine - Fun Facts","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS Copyright 2023, Harley Swick &lt;fc@daemon.pizza&gt;. Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]